# Source code of the Ubuntu-it website
# Copyright (C) 2015  Pietro Albini <pietroalbini@ubuntu.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; witout even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import flask

from uitwww import pages


def create_app(cache_path=None):
    """Create a new instance of the application"""
    app = flask.Flask(__name__, static_url_path="/+assets")

    # Apply the static cache thing
    if cache_path is not None:
        app.config["CACHE_PATH"] = cache_path
        cache.install_cache(app)

    app.register_blueprint(pages.prepare_blueprint(app))
    pages.prepare_navbar(app)

    return app
